"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.euiSideNavItemStyles = exports.euiSideNavItemButtonStyles = void 0;
var _react = require("@emotion/react");
var _services = require("../../services");
var _global_styling = require("../../global_styling");
var _title = require("../title/title.styles");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _EMOTION_STRINGIFIED_CSS_ERROR__() { return "You have tried to stringify object returned from `css` function. It isn't supposed to be used directly (e.g. as value of the `className` prop), but rather handed to emotion so it can handle it (e.g. as value of `css` prop)."; } /*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0 and the Server Side Public License, v 1; you may not use this file except
 * in compliance with, at your election, the Elastic License 2.0 or the Server
 * Side Public License, v 1.
 */
var euiSideNavItemStyles = exports.euiSideNavItemStyles = function euiSideNavItemStyles(euiThemeContext) {
  var euiTheme = euiThemeContext.euiTheme;
  var emphasizedBackgroundColor = (0, _services.transparentize)(euiTheme.colors.lightShade, 0.3);
  return {
    euiSideNavItem: /*#__PURE__*/(0, _react.css)(";label:euiSideNavItem;"),
    emphasized: /*#__PURE__*/(0, _react.css)("background-color:", emphasizedBackgroundColor, ";color:", euiTheme.colors.title, ";box-shadow:100px 0 0 0 ", emphasizedBackgroundColor, ",-100px 0 0 0 ", emphasizedBackgroundColor, ";& &{background-color:transparent;box-shadow:none;};label:emphasized;"),
    // Layout
    root: /*#__PURE__*/(0, _react.css)((0, _global_styling.logicalCSS)('padding-bottom', euiTheme.size.s), " &+&{", (0, _global_styling.logicalCSS)('margin-top', euiTheme.size.s), " ", (0, _global_styling.logicalCSS)('padding-top', euiTheme.size.s), ";};label:root;"),
    trunk: /*#__PURE__*/(0, _react.css)("color:", euiTheme.colors.title, ";;label:trunk;"),
    branch: /*#__PURE__*/(0, _react.css)("position:relative;color:", euiTheme.colors.subduedText, ";&::after{position:absolute;content:'';", (0, _global_styling.logicalCSS)('vertical', 0), " ", (0, _global_styling.logicalCSS)('left', 0), " ", (0, _global_styling.logicalCSS)('width', euiTheme.border.width.thin), " background-color:", euiTheme.border.color, ";}&:last-of-type::after{", (0, _global_styling.logicalCSS)('height', euiTheme.size.m), ";};label:branch;"),
    items: {
      euiSideNavItem__items: /*#__PURE__*/(0, _react.css)(";label:euiSideNavItem__items;"),
      rootWithIcon: /*#__PURE__*/(0, _react.css)((0, _global_styling.logicalCSS)('margin-left', euiTheme.size.l), ";;label:rootWithIcon;"),
      trunk: /*#__PURE__*/(0, _react.css)((0, _global_styling.logicalCSS)('width', '100%'), (0, _global_styling.logicalCSS)('margin-left', euiTheme.size.s), ";;label:trunk;"),
      branch: /*#__PURE__*/(0, _react.css)((0, _global_styling.logicalCSS)('margin-left', euiTheme.size.base), ";;label:branch;")
    }
  };
};
var _ref = process.env.NODE_ENV === "production" ? {
  name: "1nca8qt-euiSideNavItemButton__label",
  styles: "flex-grow:1;label:euiSideNavItemButton__label;"
} : {
  name: "1nca8qt-euiSideNavItemButton__label",
  styles: "flex-grow:1;label:euiSideNavItemButton__label;",
  toString: _EMOTION_STRINGIFIED_CSS_ERROR__
};
var euiSideNavItemButtonStyles = exports.euiSideNavItemButtonStyles = function euiSideNavItemButtonStyles(euiThemeContext) {
  var euiTheme = euiThemeContext.euiTheme;
  var lineHeightOverride = (0, _global_styling.euiFontSize)(euiThemeContext, 'm').lineHeight;

  // Create padding around focus area without indenting the item itself.
  var paddingMarginOffset = "\n    padding-inline: ".concat(euiTheme.size.s, ";\n    ").concat((0, _global_styling.logicalCSS)('margin-left', "-".concat(euiTheme.size.s)), "\n    ").concat((0, _global_styling.logicalCSS)('width', "calc(100% + ".concat((0, _global_styling.mathWithUnits)(euiTheme.size.s, function (x) {
    return x * 2;
  }), ")")), ";\n  ");
  return {
    euiSideNavItemButton: /*#__PURE__*/(0, _react.css)("display:block;", (0, _global_styling.logicalCSS)('width', '100%'), "padding-block:", euiTheme.size.xxs, ";font-size:", (0, _global_styling.euiFontSize)(euiThemeContext, 's').fontSize, ";line-height:", lineHeightOverride, ";text-align:start;color:inherit;&:is(a, button):not(:disabled){&:hover{cursor:pointer;}&:hover,&:focus{.euiSideNavItemButton__label{text-decoration:underline;}}}&:disabled{cursor:not-allowed;color:", euiTheme.colors.disabledText, ";};label:euiSideNavItemButton;"),
    selected: /*#__PURE__*/(0, _react.css)("color:", euiTheme.colors.primaryText, ";font-weight:", euiTheme.font.weight.bold, ";.euiSideNavItemButton__label{text-decoration:underline;};label:selected;"),
    emphasized: /*#__PURE__*/(0, _react.css)("font-weight:", euiTheme.font.weight.bold, ";;label:emphasized;"),
    // Layout
    root: /*#__PURE__*/(0, _react.css)((0, _global_styling.logicalCSS)('margin-bottom', euiTheme.size.xs), " padding-block:0;", paddingMarginOffset, ";;label:root;"),
    trunk: /*#__PURE__*/(0, _react.css)(paddingMarginOffset, ";;label:trunk;"),
    branch: /*#__PURE__*/(0, _react.css)("position:relative;padding-inline:", euiTheme.size.s, ";&::after{position:absolute;content:'';", (0, _global_styling.logicalCSS)('top', euiTheme.size.m), " ", (0, _global_styling.logicalCSS)('left', 0), " ", (0, _global_styling.logicalCSS)('width', euiTheme.size.xs), " ", (0, _global_styling.logicalCSS)('height', euiTheme.border.width.thin), " background-color:", euiTheme.border.color, ";};label:branch;"),
    // Child elements
    euiSideNavItemButton__content: /*#__PURE__*/(0, _react.css)("display:flex;align-items:center;gap:", euiTheme.size.s, ";;label:euiSideNavItemButton__content;"),
    label: {
      euiSideNavItemButton__label: _ref,
      root: _objectSpread(_objectSpread({}, (0, _title.euiTitle)(euiThemeContext, 'xxs')), {}, {
        lineHeight: lineHeightOverride,
        color: 'inherit'
      })
    }
  };
};