import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "className", "responsiveBreakpoint"];
/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0 and the Server Side Public License, v 1; you may not use this file except
 * in compliance with, at your election, the Elastic License 2.0 or the Server
 * Side Public License, v 1.
 */

import React from 'react';
import classNames from 'classnames';
import { useEuiMemoizedStyles } from '../../../services';
import { useIsEuiTableResponsive } from './responsive_context';
import { euiTableHeaderMobileStyles } from './table_header_mobile.styles';
import { jsx as ___EmotionJSX } from "@emotion/react";
export var EuiTableHeaderMobile = function EuiTableHeaderMobile(_ref) {
  var children = _ref.children,
    className = _ref.className,
    responsiveBreakpoint = _ref.responsiveBreakpoint,
    rest = _objectWithoutProperties(_ref, _excluded);
  var isResponsive = useIsEuiTableResponsive(responsiveBreakpoint);
  var styles = useEuiMemoizedStyles(euiTableHeaderMobileStyles);
  var classes = classNames('euiTableHeaderMobile', className);
  return isResponsive ? ___EmotionJSX("div", _extends({
    className: classes,
    css: styles.euiTableHeaderMobile
  }, rest), children) : null;
};