"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EuiHeaderSection = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _header_section = require("./header_section.styles");
var _react2 = require("@emotion/react");
var _excluded = ["side", "children", "className", "grow"];
/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0 and the Server Side Public License, v 1; you may not use this file except
 * in compliance with, at your election, the Elastic License 2.0 or the Server
 * Side Public License, v 1.
 */
var EuiHeaderSection = exports.EuiHeaderSection = function EuiHeaderSection(_ref) {
  var side = _ref.side,
    children = _ref.children,
    className = _ref.className,
    _ref$grow = _ref.grow,
    grow = _ref$grow === void 0 ? false : _ref$grow,
    rest = (0, _objectWithoutProperties2.default)(_ref, _excluded);
  var styles = (0, _header_section.euiHeaderSectionStyles)();
  var cssStyles = [styles.euiHeaderSection, grow && styles.grow, side && styles[side]];
  var classes = (0, _classnames.default)('euiHeaderSection', className);
  return (0, _react2.jsx)("div", (0, _extends2.default)({
    className: classes,
    css: cssStyles
  }, rest), children);
};
EuiHeaderSection.propTypes = {
  className: _propTypes.default.string,
  "aria-label": _propTypes.default.string,
  "data-test-subj": _propTypes.default.string,
  css: _propTypes.default.any,
  side: _propTypes.default.oneOf(["left", "right"]),
  grow: _propTypes.default.bool
};