"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EuiTableHeaderMobile = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _services = require("../../../services");
var _responsive_context = require("./responsive_context");
var _table_header_mobile = require("./table_header_mobile.styles");
var _react2 = require("@emotion/react");
var _excluded = ["children", "className", "responsiveBreakpoint"];
/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0 and the Server Side Public License, v 1; you may not use this file except
 * in compliance with, at your election, the Elastic License 2.0 or the Server
 * Side Public License, v 1.
 */
var EuiTableHeaderMobile = exports.EuiTableHeaderMobile = function EuiTableHeaderMobile(_ref) {
  var children = _ref.children,
    className = _ref.className,
    responsiveBreakpoint = _ref.responsiveBreakpoint,
    rest = (0, _objectWithoutProperties2.default)(_ref, _excluded);
  var isResponsive = (0, _responsive_context.useIsEuiTableResponsive)(responsiveBreakpoint);
  var styles = (0, _services.useEuiMemoizedStyles)(_table_header_mobile.euiTableHeaderMobileStyles);
  var classes = (0, _classnames.default)('euiTableHeaderMobile', className);
  return isResponsive ? (0, _react2.jsx)("div", (0, _extends2.default)({
    className: classes,
    css: styles.euiTableHeaderMobile
  }, rest), children) : null;
};
EuiTableHeaderMobile.propTypes = {
  className: _propTypes.default.string,
  "aria-label": _propTypes.default.string,
  "data-test-subj": _propTypes.default.string,
  css: _propTypes.default.any
};